/*
 * $RCSfile: DIOStreamSubsystem.hpp,v $
 * $Revision: 1.5 $
 * $Date: 2009/11/23 21:37:35 $
 * jEdit:tabSize=4:collapseFolds=1:
 *
 * class DIOStreamSubsystem declarations
 */


#if ! defined( DIOStreamSubsystem_hpp )
#define DIOStreamSubsystem_hpp

// {{{ includes
#include <DeviceSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class DIOStreamSubsystem declarations

/*
 * class DIOStreamSubsystem represents the digital I/O streaming subsystem of a board
 */

class DIOStreamSubsystem : public DeviceSubsystem {
public:
	DIOStreamSubsystem( USBDevice &parent );
	virtual ~DIOStreamSubsystem();

	/*
	 * properties
	 */

	virtual std::ostream &print( std::ostream &out );

	/*
	 * configuration
	 */

	DIOStreamSubsystem &setStreamingBlockSize( int blockSize );
	double setClock( bool directionRead, double clockHz );

	/*
	 * operations
	 */

	DIOStreamSubsystem &open( bool directionRead );
	DIOStreamSubsystem &close();
	UShortArray read( int numSamples );
	int write( const UShortArray &values );

	DIOStreamSubsystem &clearFIFO( int method ) {
		parent->clearFIFO( method );
		return *this;
	}	// clearFIFO()

};	// class DIOStreamSubsystem

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
