/*
 * $RCSfile: DeviceSubsystem.hpp,v $
 * $Revision: 1.7 $
 * $Date: 2009/11/23 04:24:03 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class DeviceSubsystem declarations
 */


#if ! defined( DeviceSubsystem_hpp )
#define DeviceSubsystem_hpp

// {{{ includes
#include <USBDevice.hpp>
// }}}

namespace AIOUSB {

// {{{ class DeviceSubsystem declarations

/*
 * class DeviceSubsystem represents a subsystem of a USBDevice object
 */

class DeviceSubsystem {
protected:
	USBDevice *parent;							// parent device that this subsystem is part of

public:
	DeviceSubsystem( USBDevice &parent );
	virtual ~DeviceSubsystem();

	// properties
	virtual std::ostream &print( std::ostream &out ) = 0;
	int getDeviceIndex() const;
};	// class DeviceSubsystem

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
