/*
 * $RCSfile: USB_AI16_Family.cpp,v $
 * $Revision: 1.18 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_AI16_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_AI16_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_AI16_Family implementation

USB_AI16_Family::USB_AI16_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, analogInputSubsystem( *this )
		, digitalIOSubsystem( *this )
		, counterSubsystem( *this ) {
	if(
		! (
			productID >= USB_AI16_16A
			&& productID <= USB_AI12_128E
		)
	)
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_AI16_Family::USB_AI16_Family()


USB_AI16_Family::~USB_AI16_Family() {
	// nothing to do
}	// USB_AI16_Family::~USB_AI16_Family()


ostream &USB_AI16_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	analogInputSubsystem.print( out );
	digitalIOSubsystem.print( out );
	counterSubsystem.print( out );
	return out;
}	// USB_AI16_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
