/*
 * $RCSfile: USB_AI16_Family.hpp,v $
 * $Revision: 1.14 $
 * $Date: 2009/11/23 04:24:03 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_AI16_Family declarations
 */


#if ! defined( USB_AI16_Family_hpp )
#define USB_AI16_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <AnalogInputSubsystem.hpp>
#include <DigitalIOSubsystem.hpp>
#include <CounterSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_AI16_Family declarations

/*
 * this class supports all product IDs from USB_AI16_16A to USB_AI12_128E
 */

class USB_AI16_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	AnalogInputSubsystem analogInputSubsystem;
	DigitalIOSubsystem digitalIOSubsystem;
	CounterSubsystem counterSubsystem;

public:
	USB_AI16_Family( int productID, int deviceIndex );
	virtual ~USB_AI16_Family();

	AnalogInputSubsystem &adc() {
		return analogInputSubsystem;
	}	// adc()

	DigitalIOSubsystem &dio() {
		return digitalIOSubsystem;
	}	// dio()

	CounterSubsystem &ctr() {
		return counterSubsystem;
	}	// ctr()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_AI16_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
