/*
 * $RCSfile: USB_AO16_Family.cpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_AO16_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_AO16_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_AO16_Family implementation

USB_AO16_Family::USB_AO16_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, analogOutputSubsystem( *this )
		, digitalIOSubsystem( *this ) {
	if(
		! (
			productID >= USB_AO16_16A
			&& productID <= USB_AO12_4
		)
	)
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_AO16_Family::USB_AO16_Family()


USB_AO16_Family::~USB_AO16_Family() {
	// nothing to do
}	// USB_AO16_Family::~USB_AO16_Family()


ostream &USB_AO16_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	analogOutputSubsystem.print( out );
	digitalIOSubsystem.print( out );
	return out;
}	// USB_AO16_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
