/*
 * $RCSfile: USB_AO16_Family.hpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_AO16_Family declarations
 */


#if ! defined( USB_AO16_Family_hpp )
#define USB_AO16_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <AnalogOutputSubsystem.hpp>
#include <DigitalIOSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_AO16_Family declarations

/*
 * this class supports all product IDs from USB_AO16_16A to USB_AO12_4
 */

class USB_AO16_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	AnalogOutputSubsystem analogOutputSubsystem;
	DigitalIOSubsystem digitalIOSubsystem;

public:
	USB_AO16_Family( int productID, int deviceIndex );
	virtual ~USB_AO16_Family();

	AnalogOutputSubsystem &dac() {
		return analogOutputSubsystem;
	}	// adc()

	DigitalIOSubsystem &dio() {
		return digitalIOSubsystem;
	}	// dio()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_AO16_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
