/*
 * $RCSfile: USB_CTR_15_Family.cpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_CTR_15_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_CTR_15_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_CTR_15_Family implementation

USB_CTR_15_Family::USB_CTR_15_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, counterSubsystem( *this ) {
	if( productID != USB_CTR_15 )
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_CTR_15_Family::USB_CTR_15_Family()


USB_CTR_15_Family::~USB_CTR_15_Family() {
	// nothing to do
}	// USB_CTR_15_Family::~USB_CTR_15_Family()


ostream &USB_CTR_15_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	counterSubsystem.print( out );
	return out;
}	// USB_CTR_15_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
