/*
 * $RCSfile: USB_CTR_15_Family.hpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_CTR_15_Family declarations
 */


#if ! defined( USB_CTR_15_Family_hpp )
#define USB_CTR_15_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <CounterSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_CTR_15_Family declarations

/*
 * this class supports product ID USB_CTR_15
 */

class USB_CTR_15_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	CounterSubsystem counterSubsystem;

public:
	USB_CTR_15_Family( int productID, int deviceIndex );
	virtual ~USB_CTR_15_Family();

	CounterSubsystem &ctr() {
		return counterSubsystem;
	}	// ctr()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_CTR_15_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
