/*
 * $RCSfile: USB_DIO_16_Family.cpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_16_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_DIO_16_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_DIO_16_Family implementation

USB_DIO_16_Family::USB_DIO_16_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, digitalIOSubsystem( *this )
		, dioStreamSubsystem( *this ) {
	if(
		! (
			(
				productID >= USB_DI16A_REV_A1
				&& productID <= USB_DI16A_REV_A2
			)
			|| (
				productID >= USB_DIO_16H
				&& productID <= USB_DIO_16A
			)
		)
	)
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_DIO_16_Family::USB_DIO_16_Family()


USB_DIO_16_Family::~USB_DIO_16_Family() {
	// nothing to do
}	// USB_DIO_16_Family::~USB_DIO_16_Family()


ostream &USB_DIO_16_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	digitalIOSubsystem.print( out );
	dioStreamSubsystem.print( out );
	return out;
}	// USB_DIO_16_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
