/*
 * $RCSfile: USB_DIO_16_Family.hpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_16_Family declarations
 */


#if ! defined( USB_DIO_16_Family_hpp )
#define USB_DIO_16_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <DigitalIOSubsystem.hpp>
#include <DIOStreamSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_DIO_16_Family declarations

/*
 * this class supports product IDs from USB_DI16A_REV_A1 to USB_DI16A_REV_A2, and USB_DIO_16H to USB_DIO_16A
 */

class USB_DIO_16_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	DigitalIOSubsystem digitalIOSubsystem;
	DIOStreamSubsystem dioStreamSubsystem;

public:
	USB_DIO_16_Family( int productID, int deviceIndex );
	virtual ~USB_DIO_16_Family();

	DigitalIOSubsystem &dio() {
		return digitalIOSubsystem;
	}	// dio()

	DIOStreamSubsystem &diostream() {
		return dioStreamSubsystem;
	}	// diostream()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_DIO_16_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
