/*
 * $RCSfile: USB_DIO_32_Family.cpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_32_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_DIO_32_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_DIO_32_Family implementation

USB_DIO_32_Family::USB_DIO_32_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, digitalIOSubsystem( *this )
		, counterSubsystem( *this ) {
	if( productID != USB_DIO_32 )
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_DIO_32_Family::USB_DIO_32_Family()


USB_DIO_32_Family::~USB_DIO_32_Family() {
	// nothing to do
}	// USB_DIO_32_Family::~USB_DIO_32_Family()


ostream &USB_DIO_32_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	digitalIOSubsystem.print( out );
	counterSubsystem.print( out );
	return out;
}	// USB_DIO_32_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
