/*
 * $RCSfile: USB_DIO_32_Family.hpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_32_Family declarations
 */


#if ! defined( USB_DIO_32_Family_hpp )
#define USB_DIO_32_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <DigitalIOSubsystem.hpp>
#include <CounterSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_DIO_32_Family declarations

/*
 * this class supports product ID USB_DIO_32
 */

class USB_DIO_32_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	DigitalIOSubsystem digitalIOSubsystem;
	CounterSubsystem counterSubsystem;

public:
	USB_DIO_32_Family( int productID, int deviceIndex );
	virtual ~USB_DIO_32_Family();

	DigitalIOSubsystem &dio() {
		return digitalIOSubsystem;
	}	// dio()

	CounterSubsystem &ctr() {
		return counterSubsystem;
	}	// ctr()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_DIO_32_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
