/*
 * $RCSfile: USB_DIO_Family.cpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_Family implementation
 */


// {{{ includes
#include <iostream>
#include <assert.h>
#include "USBDeviceManager.hpp"
#include "USB_DIO_Family.hpp"
// }}}

using namespace std;

namespace AIOUSB {

// {{{ class USB_DIO_Family implementation

USB_DIO_Family::USB_DIO_Family( int productID, int deviceIndex )
		: USBDevice( productID, deviceIndex )
		, digitalIOSubsystem( *this ) {
	if(
		! (
			productID == USB_DIO_48
			|| productID == USB_DIO_96
			|| productID == USB_IIRO_16
			|| productID == USB_II_16
			|| productID == USB_RO_16
			|| productID == USB_IIRO_8
			|| productID == USB_II_8
			|| productID == USB_IIRO_4
			|| productID == USB_IDIO_16
			|| productID == USB_II_16_OLD
			|| productID == USB_IDO_16
			|| productID == USB_IDIO_8
			|| productID == USB_II_8_OLD
			|| productID == USB_IDIO_4
			|| productID == USB_IIRO4_2SM
			|| productID == USB_IIRO4_COM
			|| productID == USB_DIO16RO8
			|| productID == PICO_DIO16RO8
		)
	)
		throw IllegalArgumentException( "Invalid product ID" );
}	// USB_DIO_Family::USB_DIO_Family()


USB_DIO_Family::~USB_DIO_Family() {
	// nothing to do
}	// USB_DIO_Family::~USB_DIO_Family()


ostream &USB_DIO_Family::print( ostream &out ) {
	assert( &out != 0 );
	USBDevice::print( out );
	digitalIOSubsystem.print( out );
	return out;
}	// USB_DIO_Family::print()

// }}}

}	// namespace AIOUSB


/* end of file */
