/*
 * $RCSfile: USB_DIO_Family.hpp,v $
 * $Revision: 1.1 $
 * $Date: 2009/11/24 00:52:24 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 *
 * class USB_DIO_Family declarations
 */


#if ! defined( USB_DIO_Family_hpp )
#define USB_DIO_Family_hpp

// {{{ includes
#include <USBDevice.hpp>
#include <DigitalIOSubsystem.hpp>
// }}}

namespace AIOUSB {

// {{{ class USB_DIO_Family declarations

/*
 * this class supports product IDs from USB_DIO_48 to USB_DIO_96, USB_IIRO_16 to USB_IIRO_4,
 * USB_IDIO_16 to USB_IDIO_4, USB_IIRO4_2SM, USB_IIRO4_COM USB_DIO16RO8 and PICO_DIO16RO8
 */

class USB_DIO_Family : public USBDevice {
protected:
	/*
	 * the subsystems of this device are implemented as separate objects
	 */
	DigitalIOSubsystem digitalIOSubsystem;

public:
	USB_DIO_Family( int productID, int deviceIndex );
	virtual ~USB_DIO_Family();

	DigitalIOSubsystem &dio() {
		return digitalIOSubsystem;
	}	// dio()

	virtual std::ostream &print( std::ostream &out );
};	// class USB_DIO_Family

// }}}

}	// namespace AIOUSB

#endif


/* end of file */
